#ifndef IKD_OX_BASE_OXHASH_H
#define IKD_OX_BASE_OXHASH_H

// nbVNX
//  int, float, std::string̔zAHashmapƂĕێNX
//
//   Hash hash;
//   hash["ValueI"] = 100;
//   hash["ValueF"] = 200.0f;
//   hash["ValueS"] = "Foo";
//
//   hash["ValueIA"] = std::vector<int>();
//   hash["ValueIA"] = std::vector<float>();
//   hash["ValueIA"] = std::vector<std::string>();
//
//   hash["Hash"] = Hash();
//
//   int valueI = hash["ValueI"];
//

#include "oxsp.h"
#include <string>
#include <vector>
#include <map>

namespace OX {
	class Hash {
	public:
		enum Type {
			INT,
			FLOAT,
			STR,
			INTARY,
			FLOATARY,
			STRARY,
			HASH
		};

	private:
		struct Variant;
		struct Body {
			std::map<std::string, OX::sp<Variant> > val;
		};

		struct Variant {
			Type type;
			int i;
			float f;
			std::string s;
			std::vector<int> ai;
			std::vector<float> af;
			std::vector<std::string> as;
			OX::sp<Body> b;

			Variant() : i(), f() {}

			operator int() { return i; }
			void operator =( const int &r ) { i = r; type = INT; }
			operator float() { return f; }
			void operator =( const float &r ) { f = r; type = FLOAT; }
			operator std::string() { return s; }
			void operator =( const std::string &r ) { s = r; type = STR; }
			operator std::vector<int>() { return ai; }
			void operator =( const std::vector<int> &r ) { ai = r; type = INTARY; }
			operator std::vector<float>() { return af; }
			void operator =( const std::vector<float> &r ) { af = r; type = FLOATARY; }
			operator std::vector<std::string>() { return as; }
			void operator =( const std::vector<std::string> &r ) { as = r; type = STRARY; }
			operator Hash() { return Hash(b); }
			void operator =( const Hash &r ) { b = r.body; type = HASH; }
		};

		OX::sp<Body> body;

	protected:
		Hash( OX::sp<Body> spBody ) : body( spBody ) {}

	public:
		Hash() : body( new Body ) {}

		Variant &operator []( const int &elem ) {
			char c[24];
			sprintf_s<24>( c, "%d", elem );
			return (*this)[c];
		}

		Variant &operator []( const std::string &name ) {
			std::map<std::string, OX::sp<Variant> > &m = body->val;
			if ( m.find( name ) == m.end() ) {
				OX::sp<Variant> v( new Variant );
				m.insert( std::pair<std::string, OX::sp<Variant> >( name, v ) );
				return *v.getPtr();
			}
			return *body->val[ name ].getPtr();
		}

		std::vector<std::string> getKeys() {
			std::vector<std::string> keys;
			std::map<std::string, OX::sp<Variant> > &m = body->val;
			std::map<std::string, OX::sp<Variant> >::iterator it = m.begin();
			for ( ; it != m.end(); it++ )
				keys.push_back( it->first );
			return keys;
		}
	};
}

#endif
