#ifndef IKD_OX_BASE_OXJSON_H
#define IKD_OX_BASE_OXJSON_H

// JSONwp[NX
//
//  Hash -> JSON
//  JSON -> Hash
//

#include "oxhash.h"

namespace OX {

	class Json {
	public:
		// JSONփGR[h
		static std::string encode( Hash &hash ) {
			int indentNum = 0;
			std::string outStr;
			output( outStr, "", hash, indentNum );
			return outStr;
		}

		// JSON񂩂Hash쐬
		Hash decode( const std::string &json ) {
			// ̂(>_<)
		}

	private:
		static void output( std::string &s, const std::string &key, int v ) {
			s += "\"" + key + "\":";
			char c[24];
			sprintf_s<24>(c, "%d", v);
			s += c;
		}
		static void output( std::string &s, const std::string &key, float v ) {
			s += "\"" + key + "\":";
			char c[24];
			sprintf_s<24>(c, "%f", v);
			s += c;
		}
		static void output( std::string &s, const std::string &key, std::string &v ) {
			s += "\"" + key + "\":\"" + v + "\"";
		}
		static void output( std::string &s, const std::string &key, std::vector<int> &ai ) {
			s += "\"" + key + "\":[";
			for ( size_t i = 0; i < ai.size(); i++ ) {
				char c[24];
				sprintf_s<24>(c, "%d", ai[i]);
				s += c;
				s += (i + 1 >= ai.size() ? "" : ",");
			}
			s += "]";
		}
		static void output( std::string &s, const std::string &key, std::vector<float> &af ) {
			s += "\"" + key + "\":[";
			for ( size_t i = 0; i < af.size(); i++ ) {
				char c[24];
				sprintf_s<24>(c, "%f", af[i]);
				s += c;
				s += (i + 1 >= af.size() ? "" : ",");
			}
			s += "]";
		}
		static void output( std::string &s, const std::string &key, std::vector<std::string> &as ) {
			s += "\"" + key + "\":[";
			for ( size_t i = 0; i < as.size(); i++ )
				s += "\"" + as[i] + "\"" + (i + 1 >= as.size() ? "" : ",");
			s += "]";
		}

		static void output( std::string &s, const std::string &key, Hash &hash, int indentNum ) {
		#if _DEBUG
			#define JSON_DEBUG_INDENT(s)\
				{ \
					s += "\n";\
					for ( int i = 0; i < indentNum; i++ )\
						s+= "\t";\
				}
		#else
			#define JSON_DEBUG_INDENT(s)
		#endif

			if ( key != "" )
				s += "\"" + key + "\":";
			s += "{";

			std::vector<std::string> &keys = hash.getKeys();
			indentNum += keys.size() ? 1 : 0;
			JSON_DEBUG_INDENT(s);
			for ( size_t i = 0; i < keys.size(); i++ ) {
				switch( hash[ keys[i] ].type ) {
				case Hash::INT:      output( s, keys[i], hash[ keys[i] ].i  ); break;
				case Hash::FLOAT:    output( s, keys[i], hash[ keys[i] ].f  ); break;
				case Hash::STR:      output( s, keys[i], hash[ keys[i] ].s  ); break;
				case Hash::INTARY:   output( s, keys[i], hash[ keys[i] ].ai ); break;
				case Hash::FLOATARY: output( s, keys[i], hash[ keys[i] ].af ); break;
				case Hash::STRARY:   output( s, keys[i], hash[ keys[i] ].as ); break;
				case Hash::HASH:     output( s, keys[i], (Hash)hash[ keys[i] ], indentNum ); break;
				}
				if ( i + 1 >= keys.size() )
					indentNum--;
				else 
					s += ",";
				JSON_DEBUG_INDENT(s);
			}
			s += "}";
		}
	};
}

#endif
